#!/usr/bin/python
# -*- coding: utf-8 -*-
'''
Created on 10.11.2017
    
    Custom_widgets class providing user interface widgets.  
    Copyright (C) 2018  Esa Pursiheimo

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
    
@author: Esa Pursiheimo
'''

from PySide2.QtGui import *
from PySide2.QtCore import *
from PySide2.QtWidgets import *


#------------------------------------------------------------------------------------------------------------------------------------
# Table class with copy-paste of entire table content
class QTabCustom(QTableWidget):
    def __init__(self,parent=None):
        super().__init__(parent)
    
    def keyPressEvent(self, event):
        key = event.key()        
        if key == Qt.Key_C:
            modifiers = QApplication.keyboardModifiers()
            if modifiers == Qt.ControlModifier:
                self.copy()
        else:
            QTableWidget.keyPressEvent(self, event)
            
    def copy(self):
        nro = self.rowCount()
        nco = self.columnCount()
        text = '\t'
        for col in range(nco):
            item = self.horizontalHeaderItem(col)
            if item:
                text += item.text()
            else:
                text += str(col)
            if col < nco-1:
                text += '\t'

        text += '\n'    
        for row in range(nro):
            item = self.verticalHeaderItem(row)
            if item:
                text += item.text()
            else:
                text += str(row)
            text += '\t'
            for col in range(nco):
                item = self.item(row, col)
                if item:
                    text += item.text()
                if col < nco-1:
                    text += '\t'
            text += '\n'
        QApplication.clipboard().setText(text);

#------------------------------------------------------------------------------------------------------------------------------------ 